package Nickspam;
# $Id$
#Notify nickspammers when they return.
#Nickspam is casechange in nicks to inform of wether the user is online or not.
#
#Configuration variables:
#  expire => Time in seconds to store the number of warnings.

use strict;
use base qw(Plugin);
use Common;

use Locale::gettext;
use POSIX;
setlocale(LC_MESSAGES, "");
bindtextdomain('erwin', '/usr/share/locale/');
textdomain('erwin');

sub nick
{
   my ($core, $who, $newnick) = @_;

   my %config;
   $core->module_config(\%config, '');
   return unless($config{expire});

   $who =~ /(.*)!.*/;
   my $oldnick = $1;

   #Spam if only case changes. He's present and able to read a warning if $newnick contains an uppercase character.
   if(lc($oldnick) eq lc($newnick) && $newnick =~ /[A-Z]/) {
      my $nickspam = $core->upcounter({ namespace => 'nickspam', key => lc($oldnick), expires => $config{expire}});

      #XXX - Ugly.
      my $nick = $core->hostmasks->{$newnick};
      my %userchannels = %{ $nick->[1] };
   
      my %nickconfig = %{ $core->config->{Modules}->{Nickspam} }; #configuration, with hash of channels.                                                         

      $core->log(replace('Sending nickspam warning to $NICK for the $Xth time.', {NICK => $newnick, X => $nickspam}), 6);

      my %isect;
      foreach my $channel (keys %userchannels) {
         $isect{$channel} = 1 if($nickconfig{$channel});
      }

      return unless keys %isect; #Not in any channels were it's a violation. 
      my $channels = join(", ", keys %isect); #Ok. A tad ugly. This is a list of the channels the user is in.

      $core->log($newnick, 6);

      $core->msg($newnick, replace(gettext('Hi. Changing case of nicks is considered to be public away, which is against the rules of some of the channels we both linger in ($CHANNELS). You\'ve recieved this warning $X times.'), { X => $nickspam, CHANNELS => $channels }), { notice => 1 });

   }
}

__PACKAGE__->install({
	events => { nick => 1 },
});
