package NoPaste;
# $Id$
# Tell users to paste using the paste bin, and not in the channel.

use Common;
use base qw(Plugin);

use Locale::gettext;
use POSIX;
setlocale(LC_MESSAGES, "");
bindtextdomain('erwin', '/usr/share/locale/');
textdomain('erwin');

sub public
{
   my ($core, $who, $where, $msg) = @_;

   return if($core->heap->{nick} eq $core->mynick);

   my %config;
   $core->module_config(\%config, $where);

   return unless(($config{length} && $config{count} && $config{interval}) && (length($msg) >= $config{length}));

   $core->upcounter({namespace => 'nopaste', key => $where . $who, expires => $config{interval} });

   if($core->var({ namespace => 'nopaste', key => $where . $who}) >= $config{count}) {
      $core->var({ namespace => 'nopaste', delete => $where . $who});
      $core->msg($where,replace(gettext('$NICK: Hey, hey, hey. Paste in the paste bin, not in the channel. Thanks.'), { NICK => $core->heap->{nick} }));
   }

   return;
}

__PACKAGE__->install({
	events => { public => 1 },
});
