package NoRepeat;

# $Id$
# Tell users repeating the same text to quit repeating.
# Configuration options:
#    time => time in seconds to remember what's being said.


use base qw(Plugin);
use Digest::MD5 qw(md5_base64);
use Locale::gettext;
use POSIX;
use Common;
setlocale(LC_MESSAGES, "");
bindtextdomain('erwin', '/usr/share/locale/');
textdomain('erwin');

sub public
{
   my $core = shift;
   my ($who, $where, $msg) = @_;

   my %config;
   $core->module_config(\%config, $where);
   return unless($config{time} && $config{length} && length($msg) >= $config{length});
   return if($core->heap->{nick} eq $core->mynick);

   my $hash = md5_base64($who . $where . $msg);

   if($core->var({ namespace => 'repeat', key => $hash })) {
      $core->msg($where, replace(gettext('$NICK: We\'ve heard that already. Quit repeating yourself.'), { NICK => $core->heap->{nick} }));
   }

   $core->var({namespace => 'repeat', key => $hash, value => 1, expires => $config{time}});

}

__PACKAGE__->install({
	events => { public => 1 },
});
